"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GitReport = void 0;
var faker_1 = __importDefault(require("faker"));
var GitReport = /** @class */ (function () {
    function GitReport(_a) {
        var committers = _a.committers, weeks = _a.weeks, projects = _a.projects;
        var totals = GitReport.computeTotals(committers);
        this.committers = GitReport.sortCommittersByTotalCommitsDesc(committers);
        this.weeks = weeks;
        this.projects = projects;
        this.totalCommits = totals.totalCommits;
        this.totalDeletions = totals.totalDeletions;
        this.totalFilesChanged = totals.totalFilesChanged;
        this.totalInsertions = totals.totalInsertions;
    }
    GitReport.prototype.anonymize = function () {
        return new GitReport({
            weeks: this.weeks,
            projects: this.projects,
            committers: this.committers.map(function (committer) { return (__assign(__assign({}, committer), { email: faker_1.default.internet.email(), name: faker_1.default.name.findName() })); })
        });
    };
    GitReport.sortCommittersByTotalCommitsDesc = function (committers) {
        return __spread(committers).sort(function (a, b) {
            return GitReport.computeContributionScore(b) - GitReport.computeContributionScore(a) || a.name.localeCompare(b.name);
        });
    };
    GitReport.computeTotals = function (committers) {
        return committers.reduce(function (totals, committerInfo) { return ({
            totalCommits: totals.totalCommits + committerInfo.totalCommits,
            totalDeletions: totals.totalDeletions + committerInfo.totalDeletions,
            totalFilesChanged: totals.totalFilesChanged + committerInfo.totalFilesChanged,
            totalInsertions: totals.totalInsertions + committerInfo.totalInsertions
        }); }, {
            totalCommits: 0,
            totalDeletions: 0,
            totalFilesChanged: 0,
            totalInsertions: 0
        });
    };
    GitReport.computeContributionScore = function (_a) {
        var totalCommits = _a.totalCommits, totalFilesChanged = _a.totalFilesChanged, totalInsertions = _a.totalInsertions, totalDeletions = _a.totalDeletions;
        return totalCommits + totalFilesChanged + totalInsertions + totalDeletions;
    };
    return GitReport;
}());
exports.GitReport = GitReport;
//# sourceMappingURL=gitReport.js.map