"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GitReportList = void 0;
var gitReport_1 = require("./gitReport");
/**
 * Inmutable list of git reports
 */
var GitReportList = /** @class */ (function () {
    function GitReportList(values) {
        this.values = values;
    }
    GitReportList.prototype.mergeReports = function () {
        return this.values.reduce(function (acc, report) { return new gitReport_1.GitReport({
            weeks: report.weeks,
            projects: __spread(acc.projects, report.projects),
            committers: GitReportList.combineCommitters(acc.committers, report.committers)
        }); }, GitReportList.emptyGitReport);
    };
    GitReportList.combineCommitters = function (accCommitters, committers) {
        return Object.values(__spread(accCommitters, committers).reduce(function (committersDictionary, committer) {
            var _a;
            var accumulatedCommitterInfo = GitReportList.getCommitter(committer.email, committersDictionary);
            return __assign(__assign({}, committersDictionary), (_a = {}, _a[committer.email] = {
                email: committer.email,
                name: committer.name,
                totalDeletions: committer.totalDeletions + accumulatedCommitterInfo.totalDeletions,
                totalInsertions: committer.totalInsertions + accumulatedCommitterInfo.totalInsertions,
                totalCommits: committer.totalCommits + accumulatedCommitterInfo.totalCommits,
                totalFilesChanged: committer.totalFilesChanged + accumulatedCommitterInfo.totalFilesChanged
            }, _a));
        }, {}));
    };
    GitReportList.getCommitter = function (committerEmail, committersDictionary) {
        var committer = committersDictionary[committerEmail];
        return committer || {
            email: committerEmail,
            name: '',
            totalDeletions: 0,
            totalInsertions: 0,
            totalCommits: 0,
            totalFilesChanged: 0
        };
    };
    GitReportList.emptyGitReport = new gitReport_1.GitReport({
        committers: [],
        projects: [],
        weeks: 0
    });
    return GitReportList;
}());
exports.GitReportList = GitReportList;
//# sourceMappingURL=gitReportList.js.map